<?php

namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Services;

use Teknisa\FIN\Modules\MovimentacaoBancaria\Factories\CreditoBancarioFactory;

class CreditoBancarioService {

    protected $newCode;
    protected $entityManager;
    protected $environment;
    protected $creditoBancarioFactory;
    public function __construct($entityManager, $environment, CreditoBancarioFactory $creditoBancarioFactory, $newCode){
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->creditoBancarioFactory = $creditoBancarioFactory;
        $this->newCode = $newCode;
    }

    public function validaCreditoBancario($cdreducont, $tipoCredito, $situacao, $filialProcessamento, $valorCredito){
        $contcorr = $this->creditoBancarioFactory->getContaCorrente($cdreducont, $this->environment->getNrOrgTrab());
        if ($tipoCredito = 'CHQ'){
            if ($contcorr){
                if ($contcorr->getIdctrcredchq() == 'S'){
                    $dataFiliProc = $this->creditoBancarioFactory->getDataProcessamento($filialProcessamento, $dataFiliProc);
                    $saldoDia = $this->creditoBancarioFactory->getSaldoDia($cdreducont, $dataFiliProc);
                    if($valorCredito > ($contcorr->getVrctrcredchq() + $saldoDia)){
                        throw new \Exception('Atenção! Esta operação irá ultrapassar o valor do crédito de cheque.');
                    }else{
                        if ($valorCredito > $saldoDia){
                            throw new \Exception('Atenção! Esta operação irá utilizar parte do valor do crédito de cheque.');
                        }
                    }
                }
            }
        }
        if ($tipoCredito = 'COB'){
            if ($contcorr->getIdctrcobdesc() == 'S'){
                $valorUtilizado = $contcorr->getVrutlcobdesc();
                if (!$contcorr->getVrutlcobdesc()){
                    $valorUtilizado = 0;
                }
                $valorDisponivel = $contcorr->getVrctrcobdesc() - $valorUtilizado;
                if ($valorUtilizado > $contcorr->getVrctrcobdesc()){
                    throw new \Exception('Atenção! O limite de crédito em cobrança descontada já foi ultrapassado.');
                }else if ($valorCredito > $valorDisponivel){
                    throw new \Exception('Atenção! Esta operação irá ultrapassar o valor do crédito de cheque.');
                }else if ($contcorr->getVrpercobdesc()){
                    $percentualAviso = 100 - $contcorr->getVrpercobdesc();
                    $percentualAviso = ($percentualAviso/100) * $contcorr->getVrctrcobdesc();
                    if (($valorCredito + $valorDisponivel) > ($percentualAviso)){
                        $valorPerc = $contcorr->getVrpercobdesc();
                        throw new Exception("Atenção! Esta operação irá deixar o valor de cobrança descontada abaixo dos ".$valorPerc." % parametrizado.");
                    }
                }
                $contcorr = $this->creditoBancarioFactory->updateContaCorrente($contcorr, $valorCredito);
                $this->entityManager->persist($contcorr);
            }
        }
    }

    public function updateValorUtilizadoContaCorrente($cdreducont, $valorCredito, $nrorg = null){
        $valorCredito = $valorCredito * -1;
        
        $nrorg = $nrorg?$nrorg:$this->environment->getNrOrgTrab();

        $contcorr = $this->creditoBancarioFactory->getContaCorrente($cdreducont, $nrorg);
        if($contcorr){
            $contcorr = $this->creditoBancarioFactory->updateContaCorrente($contcorr, $valorCredito);
            $this->entityManager->persist($contcorr);
        }
    }
}
