<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class FpaItrateiovinc extends \Doctrine\ORM\EntityRepository {
    
    public function getRateioVinculo($nrOrg, $nrVinculo, $mesCompetencia) {
        
        $sql = <<<SQL
SELECT ( IR.NRPESO / SUM(IR.NRPESO) OVER (PARTITION BY IR.NRORG, IR.NRVINCULOM) ) * 100 PERCENT,
       IR.*
  FROM FPA_ITRATEIOVINC IR
 INNER JOIN FPA_RATEIOVINC RV ON RV.NRORG = IR.NRORG
                             AND RV.NRRATEIOVINC = IR.NRRATEIOVINC
                             AND RV.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                            AND (RV.DTFIMVIGENCIA IS NULL OR RV.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
 WHERE IR.NRORG = :P_NRORG
   AND IR.NRVINCULOM = :P_NRVINCULOM
SQL;
        
        $param = array(
            'P_NRORG' => $nrOrg,
            'P_NRVINCULOM' => $nrVinculo,
            'P_DTMESCOMPETENC' => $mesCompetencia,
        );
        
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $param);
        
    }
}