const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po');
const classificacaoPage = require('../../../page-objects/parametrizacao/financeiro/classificacaoFinanceira.po.js');

const classificacaoGridId = '14272828943265112507417';

describe('Tela Classificação Financeira', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		classificacaoPage.abrir();
		geral.clickAplicarFiltro();
		protractorHelper.waitForElementVisibility(
			element(by.id(`grid-${classificacaoGridId}`)), 5000);
	});

	afterEach(() => {
		geral.sair();
	});

	it('Acessar tela Classificação Financeira', () => {
		expect(z.component.header.getTitle()).toBe('Classificação Financeira');
	});

	it('Adicionar uma classificação', () => {
		geral.clickAdicionar();
		classificacaoPage.adicionar(j.getValor('codigoClassificacao'), j.getValor('classificacaoFinanceira'),
			j.getValor('codigoReceita'));
		geral.clickSalvar();
		geral.filterIt(j.getValor('classificacaoFinanceira'));

		expect(geral.gridHasText(classificacaoGridId, j.getValor('classificacaoFinanceira'), 1))
			.toBe(j.getValor('classificacaoFinanceira'));
		expect(geral.gridHasText(classificacaoGridId, j.getValor('codigoClassificacao')))
			.toBe(j.getValor('codigoClassificacao'));
	});

	it('Editar registro', () => {
		geral.filterIt(j.getValor('classificacaoFinanceira'));
		geral.clickGrid('DSCLASSFINA', j.getValor('classificacaoFinanceira'), classificacaoGridId);
		geral.clickEditar();
		classificacaoPage.editar(j.getValor('classificacaoFinanceira1'), j.getValor('codigoReceita1'));
		geral.clickSalvar();
		geral.clickVoltar();
		geral.filterIt(j.getValor('classificacaoFinanceira1'));

		expect(geral.gridHasText(classificacaoGridId, j.getValor('classificacaoFinanceira1'), 1))
			.toBe(j.getValor('classificacaoFinanceira1'));
		expect(geral.gridHasText(classificacaoGridId, j.getValor('codigoClassificacao')))
			.toBe(j.getValor('codigoClassificacao'));
	});

	it('Excluir registro', () => {
		geral.filterIt(j.getValor('classificacaoFinanceira1'));
		geral.clickGrid('DSCLASSFINA', j.getValor('classificacaoFinanceira1'), classificacaoGridId);
		geral.clickExcluir();
		geral.clickSim();

		expect(geral.gridHasText(classificacaoGridId, j.getValor('classificacaoFinanceira1'), 1))
			.toBeUndefined();
		expect(geral.gridHasText(classificacaoGridId, j.getValor('codigoClassificacao')))
			.toBeUndefined();
	});
});
